### Hierarchy

- UIMenuItem
  - UIMenuCheckboxItem
  - UIMenuListItem
  - UIMenuSeparatorItem
  - UIMenuSliderItem

## Index

### Constructors

- constructor

### Properties

- _backColor
- _description
- _event
- _foreColor
- _formattedDescription
- _highlightedBackColor
- _highlightedForeColor
- _leftBadge
- _panels
- _rightBadge
- activated
- badgeLeft
- badgeRight
- enabled
- hovered
- id
- labelText
- offset
- panelActivated
- parent
- rectangle
- selected
- selectedSprite
- supportsDescription
- supportsLeftBadge
- supportsPanels
- supportsRightBadge
- supportsRightLabel
- text
- defaultBackColor
- defaultForeColor
- defaultHighlightedBackColor
- defaultHighlightedForeColor
- defaultHoveredBackColor
- defaultHoveredForeColor

### Accessors

- BackColor
- Description
- ForeColor
- FormattedDescription
- HighlightedBackColor
- HighlightedForeColor
- IsMouseInBounds
- LeftBadge
- Panels
- RightBadge
- RightLabel
- Text

### Methods

- addEvent
- addPanel
- badgeToColor
- badgeToTextureName
- draw
- findPanelIndex
- fireEvent
- formatDescription
- removePanel
- setVerticalPosition
- badgeToTextureDict
- getBadgeSize
- getBadgeSpriteHeightOffset
- getBadgeSpriteWidthOffset

## Constructors

### constructor

- new UIMenuItem(text: string, description?: string): UIMenuItem

- - Defined in ui/menu/items/UIMenuItem.ts:394

  #### Parameters

  - ##### text: string

  - ##### Optional description: string

  #### Returns UIMenuItem

## Properties

### Private _backColor

_backColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:382

### Private _description

_description: string = ''

- Defined in ui/menu/items/UIMenuItem.ts:379

### Private _event

_event: { args: unknown[]; event: string } = ...

- Defined in ui/menu/items/UIMenuItem.ts:391

#### Type declaration

- ##### args: unknown[]

- ##### event: string

### Private _foreColor

_foreColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:385

### Private _formattedDescription

_formattedDescription: string = ''

- Defined in ui/menu/items/UIMenuItem.ts:380

### Private _highlightedBackColor

_highlightedBackColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:383

### Private _highlightedForeColor

_highlightedForeColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:386

### Private _leftBadge

_leftBadge: BadgeStyle = ...

- Defined in ui/menu/items/UIMenuItem.ts:388

### Private _panels

_panels: AbstractUIMenuPanel[] = []

- Defined in ui/menu/items/UIMenuItem.ts:392

### Private _rightBadge

_rightBadge: BadgeStyle = ...

- Defined in ui/menu/items/UIMenuItem.ts:389

### Readonly activated

activated: LiteEvent = ...

- Defined in ui/menu/items/UIMenuItem.ts:361

### Protected Readonly badgeLeft

badgeLeft: Sprite

- Defined in ui/menu/items/UIMenuItem.ts:374

### Protected Readonly badgeRight

badgeRight: Sprite

- Defined in ui/menu/items/UIMenuItem.ts:375

### enabled

enabled: boolean = true

- Defined in ui/menu/items/UIMenuItem.ts:354

### hovered

hovered: boolean = false

- Defined in ui/menu/items/UIMenuItem.ts:356

### Readonly id

id: string = ...

- Defined in ui/menu/items/UIMenuItem.ts:352

### Protected Readonly labelText

labelText: Text

- Defined in ui/menu/items/UIMenuItem.ts:377

### offset

offset: Point = ...

- Defined in ui/menu/items/UIMenuItem.ts:358

### Readonly panelActivated

panelActivated: LiteEvent = ...

- Defined in ui/menu/items/UIMenuItem.ts:362

### parent

parent: undefined | Menu

- Defined in ui/menu/items/UIMenuItem.ts:359

### Protected Readonly rectangle

rectangle: Rectangle

- Defined in ui/menu/items/UIMenuItem.ts:370

### selected

selected: boolean = false

- Defined in ui/menu/items/UIMenuItem.ts:355

### Protected Readonly selectedSprite

selectedSprite: Sprite

- Defined in ui/menu/items/UIMenuItem.ts:372

### Protected supportsDescription

supportsDescription: boolean = true

- Defined in ui/menu/items/UIMenuItem.ts:364

### Protected supportsLeftBadge

supportsLeftBadge: boolean = true

- Defined in ui/menu/items/UIMenuItem.ts:366

### Protected supportsPanels

supportsPanels: boolean = true

- Defined in ui/menu/items/UIMenuItem.ts:365

### Protected supportsRightBadge

supportsRightBadge: boolean = true

- Defined in ui/menu/items/UIMenuItem.ts:367

### Protected supportsRightLabel

supportsRightLabel: boolean = true

- Defined in ui/menu/items/UIMenuItem.ts:368

### Protected Readonly text

text: Text

- Defined in ui/menu/items/UIMenuItem.ts:371

### Static defaultBackColor

defaultBackColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:344

### Static defaultForeColor

defaultForeColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:348

### Static defaultHighlightedBackColor

defaultHighlightedBackColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:345

### Static defaultHighlightedForeColor

defaultHighlightedForeColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:350

### Static defaultHoveredBackColor

defaultHoveredBackColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:346

### Static defaultHoveredForeColor

defaultHoveredForeColor: Color = ...

- Defined in ui/menu/items/UIMenuItem.ts:349

## Accessors

### BackColor

- get BackColor(): Color
- set BackColor(value: Color): void

- - Defined in ui/menu/items/UIMenuItem.ts:439

  #### Returns Color

- - Defined in ui/menu/items/UIMenuItem.ts:443

  #### Parameters

  - ##### value: Color

  #### Returns void

### Description

- get Description(): string
- set Description(value: string): void

- - Defined in ui/menu/items/UIMenuItem.ts:420

  #### Returns string

- - Defined in ui/menu/items/UIMenuItem.ts:427

  #### Parameters

  - ##### value: string

  #### Returns void

### ForeColor

- get ForeColor(): Color
- set ForeColor(value: Color): void

- - Defined in ui/menu/items/UIMenuItem.ts:459

  #### Returns Color

- - Defined in ui/menu/items/UIMenuItem.ts:463

  #### Parameters

  - ##### value: Color

  #### Returns void

### FormattedDescription

- get FormattedDescription(): string

- - Defined in ui/menu/items/UIMenuItem.ts:435

  #### Returns string

### HighlightedBackColor

- get HighlightedBackColor(): Color
- set HighlightedBackColor(value: Color): void

- - Defined in ui/menu/items/UIMenuItem.ts:449

  #### Returns Color

- - Defined in ui/menu/items/UIMenuItem.ts:453

  #### Parameters

  - ##### value: Color

  #### Returns void

### HighlightedForeColor

- get HighlightedForeColor(): Color
- set HighlightedForeColor(value: Color): void

- - Defined in ui/menu/items/UIMenuItem.ts:469

  #### Returns Color

- - Defined in ui/menu/items/UIMenuItem.ts:473

  #### Parameters

  - ##### value: Color

  #### Returns void

### IsMouseInBounds

- get IsMouseInBounds(): boolean

- - Defined in ui/menu/items/UIMenuItem.ts:525

  #### Returns boolean

### LeftBadge

- get LeftBadge(): BadgeStyle
- set LeftBadge(value: BadgeStyle): void

- - Defined in ui/menu/items/UIMenuItem.ts:477

  #### Returns BadgeStyle

- - Defined in ui/menu/items/UIMenuItem.ts:484

  #### Parameters

  - ##### value: BadgeStyle

  #### Returns void

### Panels

- get Panels(): AbstractUIMenuPanel[]
- set Panels(value: AbstractUIMenuPanel[]): void

- - Defined in ui/menu/items/UIMenuItem.ts:531

  #### Returns AbstractUIMenuPanel[]

- - Defined in ui/menu/items/UIMenuItem.ts:538

  #### Parameters

  - ##### value: AbstractUIMenuPanel[]

  #### Returns void

### RightBadge

- get RightBadge(): BadgeStyle
- set RightBadge(value: BadgeStyle): void

- - Defined in ui/menu/items/UIMenuItem.ts:494

  #### Returns BadgeStyle

- - Defined in ui/menu/items/UIMenuItem.ts:501

  #### Parameters

  - ##### value: BadgeStyle

  #### Returns void

### RightLabel

- get RightLabel(): string
- set RightLabel(value: string): void

- - Defined in ui/menu/items/UIMenuItem.ts:511

  #### Returns string

- - Defined in ui/menu/items/UIMenuItem.ts:518

  #### Parameters

  - ##### value: string

  #### Returns void

### Text

- get Text(): string
- set Text(value: string): void

- - Defined in ui/menu/items/UIMenuItem.ts:412

  #### Returns string

- - Defined in ui/menu/items/UIMenuItem.ts:416

  #### Parameters

  - ##### value: string

  #### Returns void

## Methods

### addEvent

- addEvent(event: string, ...args: unknown[]): void

- - Defined in ui/menu/items/UIMenuItem.ts:575

  #### Parameters

  - ##### event: string

  - ##### Rest ...args: unknown[]

  #### Returns void

### addPanel

- addPanel(panel: AbstractUIMenuPanel | AbstractUIMenuPanel[]): void

- - Defined in ui/menu/items/UIMenuItem.ts:545

  #### Parameters

  - ##### panel: AbstractUIMenuPanel | AbstractUIMenuPanel[]

  #### Returns void

### badgeToColor

- badgeToColor(badge: BadgeStyle): Color

- - Defined in ui/menu/items/UIMenuItem.ts:979

  #### Parameters

  - ##### badge: BadgeStyle

  #### Returns Color

### badgeToTextureName

- badgeToTextureName(badge: BadgeStyle): string

- - Defined in ui/menu/items/UIMenuItem.ts:616

  #### Parameters

  - ##### badge: BadgeStyle

  #### Returns string

### draw

- draw(): void

- - Defined in ui/menu/items/UIMenuItem.ts:1109

  #### Returns void

### findPanelIndex

- findPanelIndex(panel: AbstractUIMenuPanel): number

- - Defined in ui/menu/items/UIMenuItem.ts:556

  #### Parameters

  - ##### panel: AbstractUIMenuPanel

  #### Returns number

### fireEvent

- fireEvent(): void

- - Defined in ui/menu/items/UIMenuItem.ts:579

  #### Returns void

### formatDescription

- formatDescription(): void

- - Defined in ui/menu/items/UIMenuItem.ts:585

  #### Returns void

### removePanel

- removePanel(panelOrIndex: number | AbstractUIMenuPanel): void

- - Defined in ui/menu/items/UIMenuItem.ts:564

  #### Parameters

  - ##### panelOrIndex: number | AbstractUIMenuPanel

  #### Returns void

### setVerticalPosition

- setVerticalPosition(y: number): void

- - Defined in ui/menu/items/UIMenuItem.ts:1099

  #### Parameters

  - ##### y: number

  #### Returns void

### Static badgeToTextureDict

- badgeToTextureDict(badge: BadgeStyle): string

- - Defined in ui/menu/items/UIMenuItem.ts:7

  #### Parameters

  - ##### badge: BadgeStyle

  #### Returns string

### Static getBadgeSize

- getBadgeSize(badge: BadgeStyle): Size

- - Defined in ui/menu/items/UIMenuItem.ts:182

  #### Parameters

  - ##### badge: BadgeStyle

  #### Returns Size

### Static getBadgeSpriteHeightOffset

- getBadgeSpriteHeightOffset(sprite: Sprite): number

- - Defined in ui/menu/items/UIMenuItem.ts:178

  #### Parameters

  - ##### sprite: Sprite

  #### Returns number

### Static getBadgeSpriteWidthOffset

- getBadgeSpriteWidthOffset(sprite: Sprite): number

- - Defined in ui/menu/items/UIMenuItem.ts:174

  #### Parameters

  - ##### sprite: Sprite

  #### Returns number

Generated using TypeDoc